#include "../minion.h"
AbstractConstraint* build_constraint_CT_ELEMENT(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_ELEMENT_ONE(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_ELEMENT(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_ELEMENT_ONE(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_ELEMENT_UNDEFZERO(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_GACELEMENT(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_ALLDIFF(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_GACALLDIFF(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_GCC(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_GCCWEAK(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_NEQ(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_DISEQ(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_DISEQ_REIFY(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_EQ(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_EQ_REIFY(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_MINUSEQ(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_MINUSEQ_REIFY(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_ABS(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_INEQ(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_LESS(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_GACLEXLEQ(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_QUICK_LEXLEQ(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_LEXLEQ(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_LEXLESS(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_QUICK_LEXLESS(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_MAX(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_MIN(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_OCCURRENCE(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_LEQ_OCCURRENCE(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_GEQ_OCCURRENCE(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_PRODUCT2(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_DIFFERENCE(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WEIGHTLEQSUM(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WEIGHTGEQSUM(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_GEQSUM(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_LEQSUM(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_GEQSUM(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_LEQSUM(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_TABLE(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_NEGATIVE_TABLE(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_VECNEQ(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_STATIC_VECNEQ(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_LITSUM(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_POW(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_DIV(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_DIV_UNDEFZERO(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_MODULO(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_MODULO_UNDEFZERO(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_GADGET(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_OR(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_HAMMING(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_NOT_HAMMING(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_NEW_OR(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_NEW_AND(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_INSET(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_ININTERVALSET(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_NOT_INSET(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_INRANGE(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_NOT_INRANGE(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_LIT(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_NOTLIT(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_REIFY(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_REIFYIMPLY_QUICK(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_REIFYIMPLY(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_TRUE(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_FALSE(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_CHECK_GSA(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_CHECK_ASSIGN(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_FORWARD_CHECKING(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_WATCHED_VEC_OR_LESS(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_LIGHTTABLE(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_HAGGISGAC(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_HAGGISGAC_STABLE(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_STR(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_SHORTSTR(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_GACEQ(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_GACSCHEMA(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_MDDC(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_NEGATIVEMDDC(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_TEST(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_VM(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_VM_SYM(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_TABLE_VM(StateObj* stateObj, ConstraintBlob&);
AbstractConstraint* build_constraint_CT_NEG_TABLE_VM(StateObj* stateObj, ConstraintBlob&);
